*! Version 2.0 --  2may05, 14mar2002   
program define canred  
  version 9.0
  if "`e(cmd)'" ~= "canon" { 
    error 301
  }
  args lc
  if `lc' > e(n_cc) {
    display as err "Number of canonical correlations cannot exceed `e(n_cc)'"
    error 301
  }

  matrix cc = e(ccorr)

  local n1 = rowsof( e(canload11) )   
  local n2 = rowsof( e(canload22) )   
 
  local cc  = el(cc,1,`lc')
  local cc2 = el(cc,1,`lc')^2
  tempvar uvar vvar
  predict `uvar', u corr(`lc')
  predict `vvar', v corr(`lc')

  local ruow = 0
  local ruop = 0
  local rvow = 0
  local rvop = 0
  
  display
  display in green "Canonical redundancy analysis for canonical correlation " `lc'
    display
  display in green "Canonical correlation coefficient        " /*
  */    in yellow %8.4f `cc'
  display in green "Squared canonical correlation coefficient" /*
    */    in yellow %8.4f `cc2'
  display

  local vars11 : rownames( e(canload11) )
  tokenize `vars11'
  local i = 1
  while `i' <= `n1' {
    quietly corr ``i''  `uvar'
    local ruow = `ruow' +  r(rho)^2
    local i = `i' + 1
  }

  local vars22 : rownames( e(canload22) )
  tokenize `vars22'
  local i = 1
   while `i' <= `n2' {
     quietly corr ``i'' `vvar'
     local rvow = `rvow' +  r(rho)^2
     local i = `i' + 1
  }
  
  local ruow = `ruow'/`n1'
  local rvow = `rvow'/`n2'
  local ruop = `ruow' * `cc2'
  local rvop = `rvow' * `cc2'


  display in green "                                       own    opposite"
  display in green "Proportion of standardized variance  variate   variate "
  display in green "           of u variables with ..." in yellow %10.4f  `ruow' %10.4f  `ruop'
  display in green "           of v variables with ..." in yellow %10.4f  `rvow' %10.4f  `rvop' 
  scalar drop _all
  matrix drop cc
end
